string Description = "Basic Texturing";

texture DiffuseTexture : Diffuse
<
	string ResourceName = "texture.dds";
>;

sampler DiffuseMap = sampler_state
{
	texture = <DiffuseTexture>;
	MAGFILTER = LINEAR;
	MINFILTER = LINEAR;
	MIPFILTER = LINEAR;
};

float4x4 WVP : WorldViewProjection;

struct AppData
{
    float3 position : POSITION;
    float2 uv : TEXCOORD0;
};

struct VertexOutput
{
    float4 hPosition : POSITION;
    float2 uv : TEXCOORD0;
};

struct PixelOutput
{
    float4 color : COLOR;
};

VertexOutput VS_Transform(AppData IN) 
{
    VertexOutput OUT;
    OUT.hPosition = mul(float4(IN.position, 1.0), WVP);
    OUT.uv = IN.uv;
    return OUT;
}

PixelOutput PS_Texture(VertexOutput IN)
{
	PixelOutput OUT;
	OUT.color = tex2D(DiffuseMap, IN.uv);
	return OUT;
}

technique simpleTechnique
{
    pass p0 
    {		
		VertexShader = compile vs_2_0 VS_Transform();
		PixelShader  = compile ps_2_0 PS_Texture();
    }
}